Subject: Re: [PATCH 2/2] Add the of_find_i2c_device_by_node function, V4

From: Jean Delvare <[email-masked]>
Date: Tue, 1 Jul 2008 19:01:51 +0200

On Tue, 1 Jul 2008 10:45:18 -0600, Grant Likely wrote:
> On Tue, Jul 01, 2008 at 06:29:49PM +0200, Jean Delvare wrote:
> > On Tue, 1 Jul 2008 11:12:58 -0400, Jon Smirl wrote:
> > > On 7/1/08, Jean Delvare <[email-masked]> wrote:
> > > > I'm fine with this patch. In particular, exporting i2c_bus_type is OK.
> > > >  It was un-exported only because it had no user left, but it can be
> > > >  exported again if needed.
> > > 
> > > Another solution would be to move drivers/of/of_i2c into the i2c
> > > directory and make it part of i2c core on powerpc builds.
> > 
> > I don't think this is a good idea. Merging arch-specific code (or
> > half-arch-specific code in this case) into arch-neutral drivers ends up
> > being a pain to maintain. People will keep sending me patches for stuff
> > I don't know anything about and can't help with. Having of-specific
> > stuff in just one directory as is the case now sounds much better to
> > me. All it's missing is a MAINTAINERS entry.
> 
> But the other side of the coin is that each driver must have
> driver-specific OF code to translate data in the device tree to data
> usable by the driver.  It doesn't make any sense to me for that stuff to
> live anywhere other that with the driver that it supports.

This code is glue between OF and subsystems. As with any glue code, you
can argue forever on which side you want to push the code to. Both
answers are valid.

All I see on my personal side is that I don't have any system using OF
and no knowledge about it either, so I can't maintain of_i2c. So having
that file in drivers/of rather than drivers/i2c will make my life
easier for sure. While I'd guess that most (all?) OF-based systems have
an I2C bus, so whoever is responsible for drivers/of should be able to
maintain of_i2c.

-- 
Jean Delvare